unit ListBoxInRichedit;

      //////////////////////////////////////////////////////////////
      //                                                          //
      // il faut taper un texte puis appuyer sur le bouton        //
      //  Exemple de ReMix (Eric ZALI)                            //                             //
      //                                                          //
      //////////////////////////////////////////////////////////////
      
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
   ModeResize= (WE,NWSE,NS,AUCUN);
  TForm1 = class(TForm)
    Button1: TButton;
    StatusBar3: TStatusBar;
    Panel2: TPanel;
    RichEdit1: TRichEdit;
    Panel1: TPanel;
    ListBox1: TListBox;
     procedure Button1Click(Sender: TObject);
    procedure Panel1CanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RichEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    PopupActive:boolean;
    ResizeLIste:ModeResize;
    ResizeenCours:Boolean;
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}



procedure TForm1.Button1Click(Sender: TObject);
var
    PosCur : tpoint;
begin
   ResizeenCours:=false;
    getcaretpos(PosCur);
    with panel1 do
    begin
      Top :=PosCur.Y - RichEdit1.Font.Height +4;
      Left := PosCur.X + 2;
      Show;
    end;
    listbox1.SetFocus;
    listbox1.ItemIndex :=0;
end;


procedure TForm1.Panel1CanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
resize:=true;
end;

procedure TForm1.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (Shift=[ssCtrl]) and (key=VK_SPACE) then
   begin
      Button1Click(nil);
      PopupActive:=true;
   end;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
   Richedit1.SelText:=listbox1.Items[ListBox1.ItemIndex];
   Panel1.Hide;
   Richedit1.SetFocus;
end;

procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    case key of
    VK_RETURN:ListBox1DblClick(nil);
    VK_ESCAPE:begin
               Panel1.Hide;
               Richedit1.SetFocus;
              end;
   end;
end;


procedure TForm1.RichEdit1KeyPress(Sender: TObject; var Key: Char);
begin
   if PopupActive then
   begin
      key:=#0;
      PopupActive:=false;
   end;
end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ResizeenCours then
  begin
    case ResizeLIste of
       WE:Panel1.Width:=X ;
       NWSE:begin
             Panel1.Width:=X;
             Panel1.Height:=Y;
            end;
       NS:Panel1.Height:=Y;
    end;
  end
  else
  begin
    if (x>Panel1.Width-4) and (x<Panel1.Width) then
    begin
       if (y>Panel1.Height-4) and (y<Panel1.Height) then
        begin
           panel1.Cursor:=crSizeNWSE;
           ResizeLIste:=NWSE;
        end
       else
        begin
           Panel1.Cursor:=crSizeWE;
           ResizeLIste:=WE;
        end;
    end
    else if (y>Panel1.Height-4) and (y<Panel1.Height) then
    begin
        Panel1.Cursor:=crSizeNS;
        ResizeLIste:=NS;
    end
    else
    begin
       Panel1.Cursor:=crDefault;
       ResizeLIste:=AUCUN;
    end;
  end;
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ResizeLIste<>AUCUN then ResizeenCours:=true;
end;

procedure TForm1.Panel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ResizeenCours then
case ResizeLIste of
     WE:Panel1.Width:=X ;
     NWSE:begin
           Panel1.Width:=X;
           Panel1.Height:=Y;
          end;
     NS:Panel1.Height:=Y;
  end;
ResizeenCours:=false;
end;

end.
